/***********************************************************************
*                                                                      *
*    CAPRICELLI Thomas  /  Orzel         Copyright 1995,96             *
*                                                                      *
*     file    : isprime.c                                              *
*     begin   : ? 06/95                                                *
*     rub     : misc                                                   *
*     subject : prime numbers...                                       *
*                                                                      *
*        $Id: isprime.c,v 1.1.1.1 1999/11/05 12:51:48 orzel Exp $
*                                                                      *
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define FLAG_TEST   0x01
#define RCS_ID      "$Id: isprime.c,v 1.1.1.1 1999/11/05 12:51:48 orzel Exp $"

void nieme(unsigned long);
void isprime(unsigned long);
void help(void);
void error(char *w)
{
puts(w); exit(1); 
}

FILE *f;

int main(int argc, char **argv)
{
unsigned long pos;
int i, test=0;
char *prime_path;

/* PRIME_PATH */
prime_path = getenv("PRIME_PATH");
if (!prime_path)
  {
  puts("Can't get var PRIME_PATH, use ./prime.dat");
  prime_path = "prime.dat";
  }

/* ouverture fichier AVANT parsing des arguments */
f = fopen(prime_path,"r");
if (f==NULL)
  {
  printf("I tried \"%s\" file whithout success.\n", prime_path);
  error("erreur ouverture fichier");
  }

/* arguments */
for (i = 1; i < argc; i++)
  if (argv[i][0]=='-')
    switch (argv[i][1])
      {
      case '-':
        if (!strcmp ("version", argv[i] + 2))
             error(RCS_ID);
        if (!strcmp ("help", argv[i] + 2))
             help ();
        error ("Unknown option");
      case 't':
        test |= FLAG_TEST;
        break;
      default:
        error ("Unknown option");
      }
  else  
      {
      pos = strtoul(argv[i], (char **)NULL, 10);
      if (pos == 0ul)
        { 
        puts("Il n'y a pas de nombre premier numerote 0");
        continue;
        }
      if (test) isprime(pos); else nieme(pos);
      }
/* c'est fini, snif... */
fclose(f);
return 0;
}

void nieme(unsigned long n)
{
unsigned long nbre;
if (fseek(f, (n-1)*sizeof(unsigned long), SEEK_SET))
      error("pas assez de nbre premier calcule...");
if (n>1000700ul)
      error("pas assez de nbre premier calcule...(2)");

fread(&nbre, sizeof(unsigned long), 1, f);
printf("prime %lu = %lu\n", n, nbre);
}

void isprime(unsigned long n)
{
unsigned long a, b, c;
unsigned long nbre;

fseek(f, 1000699ul*sizeof(unsigned long), SEEK_SET);
fread(&nbre, sizeof(unsigned long), 1, f);
if (n==nbre) 
  {printf("prime %lu = %lu\n", 1000700lu, n); return;}
if (n<nbre)
  {
  /* recherche dichotomique */
  a=0; b=1000700ul - 1 ;
  while (b-a>1)
    {
    c=(a+b)/2; /* a+b < UNSIGNED_MAX */
    fseek(f, c*sizeof(unsigned long), SEEK_SET);
    fread(&nbre, sizeof(unsigned long), 1, f);
    if (nbre==n) a=b=c;
    if (nbre>n) b=c; else a=c; 
    } /* while */
  if (b==a) printf("prime %lu = %lu\n", a+1, n);
      else  printf("%lu n'est pas premier\n", n);
  /*printf("fin dichoto a:%lu b:%lu nbre:%lu n:%lu\n",a, b, nbre, n);*/
  }
else
  {
  fseek(f, 0L, SEEK_SET); nbre = 0ul;
  while (nbre*nbre < n)
    {
    fread(&nbre, sizeof(unsigned long), 1, f);
    if (n%nbre==0) 
      {
      printf("%lu n'est pas premier, il est divise par %lu\n", n, nbre);
      return;
      }
    } /* while */
  printf("%lu hop est premier. (mais j'ignore le combien-ieme !)\n", n);

  } /* else */
}

void help(void)
{
puts("");
puts("isprime (C) Thomas CAPRICELLI 1995");
puts("");
puts("usage : isprime [--version] [--help] nber ... [-t] nber....");
puts("");
puts("        -t : ask if nber is prime");
puts("        else : give the nber-th prime number");
puts("        You can't ask for a number bigger than 4294967295");
puts("If a env variable PRIME_PATH is defined, it will be used as the input file.");
puts("Else, the file ./prime.dat will be used.");
exit(0);
}
