/***********************************************************************
*                                                                      *
*    CAPRICELLI Thomas  /  Orzel         Copyright 1995,96             *
*                                                                      *
*     file    : premier.c                                              *
*     begin   : ?  06/95                                               *
*     rub     : misc                                                   *
*     subject : prime numbers. Create a file with (double)             *
*               10005000 first prime numbers                           *
*                                                                      *
*        $Id: premier.c,v 1.0 1995/08/02 12:15:59 orzel Exp &          *
*                                                                      *
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAX_PRIME 1000000L  /* 1 million */
#define BUF_SIZE  10000
#define PREPRE_SIZE 700

/* PREPRE_SIZE determine les nombres premiers qu'on garde
   ram.
   avec 700, on peut chercher les nombres premier jusqu'a
   premier(700) a carre, c'est a dire :
   5279*5279 = 27.867.841
*/


typedef unsigned long ul;

int test(ul);
ul  prepre[PREPRE_SIZE];  /* premiers nombres premiers */
ul  buffer[BUF_SIZE];     /* buffer pour le disque */

FILE  *f;
ul  i, compte;

inline void fill_buffer(void)
{
int x;      /* indice dans le buffer */
for(x=0; x<BUF_SIZE;)
   {
   i++; i++;  /* 2 est le seul nombre pair premier */
   if (test(i))
       { buffer[x++] = i; compte++;}
   }
}
 
inline void save_buffer(void)
{
fwrite(buffer, sizeof(ul), BUF_SIZE, f);   
printf("prime %lu = %lu\n", compte, buffer[BUF_SIZE-1]);
}

int main(int argc)
{
int x;
/*       initialisation   */

i=1;compte = 1; 
buffer[0]=prepre[0]=2; /* le premier est 2, sisi... */

if (argc != 1) 
  {
  puts(
"premier (c) CAPRICELLI Thomas 1995\n"
"   put the 1'000'500 first prime numbers in the file prime.dat\n"
"   in 'unsigned long' format, whithout any header.\n"
"Why is it so useful ? Only in order to use 'prime', who need this file !\n" );
  exit(1);
  }

/* ouverture fichier */
f = fopen("prime.dat","w");
if (f==NULL)
  {  puts("erreur ouverture fichier"); exit(1); }

/*   remplissage prepre   */
for(x=1; x<PREPRE_SIZE;)
   {
   i++; i++;
   if (test(i))
       {
       compte++;
       prepre[x] = buffer[x] = i;
       x++;
       /*printf("prime %d = %lu\n", compte, i);*/
       }
   }
fwrite(buffer, sizeof(ul), PREPRE_SIZE, f);
puts("Fin de remplissage de PREPRE");

while(compte<1000001L)
   {
   fill_buffer();
   save_buffer();
   }
fclose(f);
return 0;
}



int test(ul t) /* return premier? */
{
register int i; /* variables inline ! ?? */
register ul  p;
for(i=0;(p=prepre[i])*p<=t; i++)
  if (t%prepre[i]==0)
    return 0;
return 1;
}
